
BEGIN { phase = 0 ;
  rem = 0 ; 
  print "dot2fc2: output to '" OFILE "'";
  lineno = 0 ;
}
/\/\*.*\*\// { next ; }
/\/\*.*/ { rem = 1 ; next ; } 
/.*\*\// { rem = 0 ; next ; }
/./ { if ( rem == 1) 
         next ; 
}
/digraph/ {
  phase ++ ;
  if (phase == 1) {
    print "dot2fc2: begin phase 1.." ;
    dotname = substr($0, match($0,/"[a-zA-Z0-9_\-]+"/), RLENGTH);
    print "% Fc2 file generated from dot2fc2 by Yung-Pin Cheng" > OFILE ;
    print "version \"1.1\"" > OFILE ;
    print "nets 1" > OFILE ;
    print "hook\"main\" > 0" > OFILE ;
    print "struct" dotname > OFILE ;
    print "net 0" > OFILE ;
    j = 0 ; 
    vno = 0 ;
  }
  if (phase == 2) {
    print "dot2fc2: begin phase 2.." ;
    print "B" j > OFILE  ;
    for (i=0;i< j; i++) {
      print ":" i " " "\"" exports[i] "\"" > OFILE;
    }
    print "" > OFILE ;
    print "l \"initial\">" start " h \"automaton\""> OFILE ;
    print "V" vno > OFILE;
    p2vno = -1 ;
    lineno = 1 ;
  }
}
/\->/ {
  if (phase == 1) {
    remains = substr($0,index($0,"label"));
    label = substr(remains, match(remains,/"[a-z0-9A-Z_\-\.,() ]+"/),
                   RLENGTH);
    if (label != "") {
      label = becomeXXYY(label);
      found = 0 ;
      for (i=0;i<j; i++) 
	if (exports[i] == label) {
	  found = 1 ;
	  break ;
	}
      if (found == 0 ) {
	exports[j] = label ;
	j++ ;
      }
    }
    edgeno[vno-1] ++ ;
  } 
  if (phase == 2) {
    from = substr($0, match($0,/"[0-9a-zA-Z\.\-]+"/), RLENGTH) ;
    if (from == nodestr[p2vno]) {
      remains = substr($0,index($0,"label"));
      label = substr(remains, match(remains,/"[a-z0-9A-Z_\-\.,() ]+"/),
		     RLENGTH);
      remains = substr($0,index($0,"->"));
      to = substr(remains, match(remains,/"[0-9a-zA-Z\.\-]+"/), RLENGTH);
      if (label == "") 
	print "e" eno " b tau r " hash[to] > OFILE ;
      else
	print "e" eno " b \"" becomeXXYY(label) "\" r " hash[to] > OFILE;
      eno ++ ;
    } else 
      print "ERROR: line " FNR " should be moved below the node " from ;
  }
}
/"[0-9a-zA-Z\.\-]+" *\[ *shape *= *ellipse/ {
  if (phase == 1) {
    nodename = substr($0,match($0,/"[0-9a-zA-Z\.\-]+"/), RLENGTH);
    nodestr[vno] = nodename ;
    edgeno[vno] = 0 ;
    hash[nodename] = vno ;
    vno ++ ;
  } else if (phase == 2) {
    p2vno ++ ;
    print "v" p2vno " E" edgeno[p2vno] > OFILE ;
    eno = 0 ;
  }
}
/"[0-9a-zA-Z\.\-]+" *\[ *shape *= *box/ {
  if (phase == 1) {
    nodename = substr($0,match($0,/"[0-9a-zA-Z\.\-]+"/), RLENGTH);
    nodestr[vno] = nodename ;
    edgeno[vno] = 0 ;
    hash[nodename] = vno ;
    start = vno ;
    vno ++ ;
  } else if (phase == 2 ) {
    p2vno ++ ;
    print "v" p2vno " E" edgeno[p2vno] > OFILE ;
    eno = 0 ;
  }
}
END {
  print "dot2fc2 done." ;
}

function searchnodestr(name) {
  for (k=0;k< vno; k++) {
    if (nodestr[k] == name) {
      return k ;
    }
  }
}
function becomeXXYY(name) {
  
  noquote = substr(name,2,length(name)-2);
  if (index(noquote,".") == 0) {
   # there is no ., so the name is like -xxxx(yyyy,zzzz); 
   nodash = substr(noquote,index(noquote,"-")+1);   
   leftp = index(nodash,"(");
   rightp = index(nodash,")");
   if (leftp != 0) {
       entry = substr(nodash, 
	              1,
		      leftp-1);
        para = substr(nodash, leftp+1, rightp-leftp-1);
       gsub(/ *, */,"ZZ",para);
       return substr(dotname,2,length(dotname)-2) "XX" entry "YY" para ;
   } else {
    entry = nodash;
    para = "" ;
    return  substr(dotname,2,length(dotname)-2) "XX" entry ;
   }
  }
  nodash = substr(noquote,index(noquote,"-")+1);
  dotpos = index(nodash,".");
  task = substr(nodash,1, dotpos-1);
  leftp = index(nodash,"(");
  rightp = index(nodash,")");
  if (leftp != 0) {
     
    entry = substr(nodash, 
		   dotpos+1,
		   leftp-dotpos-1);
    para = substr(nodash, leftp+1, rightp-leftp-1);
     
    gsub(/ *, */,"ZZ",para);
    return task "XX" entry "YY" para ;
  } else {
    entry = substr(nodash, dotpos+1);
    para = "" ;
    return task "XX" entry ;
  }

}


    
    
      
	

