BEGIN {
  dotname = "" ;
  vertex = 0 ;
  initial = 0 ;
  structcoming = 0 ;
}
/struct/ { 
  dotname = substr($0,match($0,/"[a-zA-Z0-9_]+"/), RLENGTH);
} 
/S1/ {
# this format happens wen fc2 file is generated from fc2explicit
  structcoming = 1 ;
}
/"initial"/ { 
  initial = 1 ;
  if (dotname == "") {
    if (name == "") {
      print "ERROR: please give a name for this FC2 file" ;
      print "usage: fc2dot .fc2 .dot name " ;
      exit 1 ;
    }
    /* there is no "struct" in the fc2 file */
    print "digraph \"" name "\" {" > ofile ;
    taskname = name ;
  } else {
    print "digraph " dotname "{"  > ofile ;
    taskname = substr(dotname,2,length(dotname)-2);
  }
  
   start = substr($0,match($0,/[0-9]+/),RLENGTH) ;
}
/:[0-9]+/ {
  /* this type of format only happen when a fc2 file is generated from atg */
  no = substr($0, match($0,/[0-9]+/), RLENGTH);
  str = substr($0,match($0,/"[a-z0-9A-Z_\-\.,()]+"/), RLENGTH);
  if (structcoming==1) {
    dotname = str ;
    structcoming = 0 ;
  } else
    bstr[no] = str ;
}
/^v[0-9]+/ {
  vno = substr($0,match($0,/[0-9]+/), RLENGTH);
  if (vno == start) 
    print "\"" vno ".1\"" "[shape = box, style = filled, color = blue ];" > ofile ;
  else
    print "\"" vno ".1\"" "[shape = ellipse, style = filled, color = white ];" > ofile ;
}
/^e[0-9]+/ {
  for (i=1;i<=NF; i++) {
    if ($i == "r") {
      tostr = $(i+1) ;
    }
    if ($i == "b") {
      edgelabel = $(i+1);
    }
  }
  pos =  match($0,/"[a-z0-9A-Z_\-\.,()]+"/);
  if (pos != 0) {
    label = substr($0,pos,RLENGTH);
    if (reverse==1) {
      label = reverseXXYY(label);
    }
    
    print "\"" vno ".1\" -> \"" tostr ".1\" [ label=" label "];" > ofile ;
  } else {
    // this is the case of tau
     print "\"" vno ".1\" -> \"" tostr ".1\" [ label=\"\", color=gold ];" > ofile;
  }
}
/vertex *[0-9]+/ {
  vno = substr($0,match($0,/[0-9]+/), RLENGTH);
  if (vno == start) 
    print "\"" vno ".1\"" "[shape = box, style = filled, color = blue ];" > ofile ;
  else
    print "\"" vno ".1\"" "[shape = ellipse, style = filled, color = white ];" > ofile ;
}
/behav *[0-9]+/ {
  lno = substr($0,match($0,/[0-9]+/), RLENGTH);
}
/behav *tau/ {
  lno = "@" ;
}
/\-> *[0-9]+/ {
  destno = substr($0,match($0,/[0-9]+/), RLENGTH);
  if (lno == "@") 
    print "\"" vno ".1\" -> \"" destno ".1\" [ label=\"\", color=gold ];" > ofile;  
  else {
    label = bstr[lno] ;
    if (reverse==1) 
      label = reverseXXYY(label);    
    print "\"" vno ".1\" -> \"" destno ".1\" [ label=" label "];" > ofile ;
  }
}
END {
  print "}" > ofile ;
  if (initial != 1) {
    print "ERROR: no start node assigned in the given fc2 file" ;
    print "       Please fix the fc2 file ";
    exit 1 ;
  }
}
function reverseXXYY(lb) {
  /* print lb ;*/
  if (match(lb,/XX/)==0) return lb ;
  task = substr(lb,2,match(lb,/XX/)-2);
  /* print "task=" task ; */
  bg = match(lb,/XX/) ;
  if (bg == 0) return lb ;
  bg  += 2 ;
  /* print "entry=" entry ;*/
  yno = match(lb,/YY/);
  if (yno == 0) {
    entry = substr(lb, bg, length(lb)-bg);    
    if (task == taskname) 
      return "\"-" task "." entry "\"" ;
    else
      return "\"" task "." entry "\"" ;
  } else 
    entry = substr(lb, bg, match(lb,/YY/)-bg);  
  
  bg = match(lb,/YY/)+ 2;
  if (task == taskname) 
    retstr = "\"-" task "." entry "(" ;
  else
    retstr = "\"" task "." entry "(" ;
    
  body = substr(lb, bg, length(lb)-bg) ;
  while (1) {
    end = match(body,/ZZ/);
    if (end == 0) {
      return retstr body ")\"" ;
    }
    else {
      retstr = retstr substr(body,1,end-1) "," ;
      body = substr(body, end+2);
    }
  }
}
   
    
   

  
  
  
  

    
  
  
  

           
